stages:
  - test
  - deploy
  - verify

test_unit_python:
  stage: test
  image: python:3
  script:
    - cd tests
    - PYTHONPATH=.. python -m unittest

upload_to_pypi.org:
  stage: deploy
  image: python:3
  dependencies:
    - test_unit_python
  script:
    - pip install -U twine
    - python setup.py sdist
    - twine upload dist/*
  only:
    refs:
      - master
    variables:  # We make sure that a new version have been realised before uploading the module
      - $CI_COMMIT_MESSAGE =~ /Version [0-9]+\.[0-9]+\.[0-9]+/
      - $CI_COMMIT_TAG =~ /v[0-9]+\.[0-9]+\.[0-9]+/

verify_pypi_module:
  stage: verify
  image: python:3
  dependencies:
    - upload_to_pypi.org
  script:
    - sleep 300  # Wait 5 minutes that the register finish updating
    - cd verifier_script
    - pip install -r requirements.txt
    - python simple_checksum_compute.py | diff --strip-trailing-cr ../result_expected.txt -
